#include <iostream.h>
#define MAX 9000

int p,k;
unsigned long a[MAX];
int b[MAX];

int main()
{
	cin>>p>>k;
	int i,j;
	for(i=2;i<MAX;i++)
	{
		b[i]=i;
	}
	for(i=4;i<MAX;i++)
	{
		for(j=2;j<i;j++)
		{
			if(i%j==0)
			{
				b[i]=0;
				break;
			}
		}
	}
	for(i=2;i<MAX;i++)
	{
		if(b[i]!=0) a[i]=1;
	}
	for(i=4;i<MAX;i++)
	{
		if(a[i]!=1)
		{
			for(j=2;j<i;j++)
				if(i%j==0) break;
			a[i]=j*(a[i/j])+(a[j])*(i/j);
		}
	}
	for(i=0;i<k;i++)
	{
		p=a[p];
	}
	cout<<p<<endl;
	return 0;
}